/**
 *	_tbl.c --  for server side, for tbl_XX() functions
 *
 *		N.Kamikubota, June 11, 1992
 *
 * module structure:
 *	[ rtbllib ]     [client]               [server]     [ tbllib ]
 *	tbl_read() --+-- _rtbl()  <SC-SERVER>  _tbl() --+-- tbl_read()
 *	tbl_param() -+                                  +-- tbl_param()
 *	tbl_int() ---+                                  +-- tbl_int()
 *	tbl_node() --+                                  +-- tbl_node()
 * note:
 *  rtbllib and tbllib supplies same tbl_XX functions. 
 *  tbllib uses a local-host table, while rtbllib reads the remote-host tabel. 
 *  rtbllib requires a daemon (rtbld) in the remote-host. 
 *
 * not yet optimised for version 2
 *
**/
static char what__tb2[] =
"@(#)_tbl.c, v2.1.0, n.k, linac table server side routine, jun.1992-may.1997";


/***********************************/
/* definitions  & global variables */
/***********************************/
#include	<stdio.h>
#include	"rtb2.h"	/* "tbl.h" included in "rtbl.h" */

/*** tbl_XX() functions ***/
int	tbl_read(), tbl_param(), tbl_int();
char	*tbl_node();

/********************************************/
/**  _tbl  --  server part of the rtbllib  **/
/********************************************/
int _tbl( com, name, buf )
char	*com;			/* command */
char	*name;			/* name */
union sc_uarg	*buf;		/* paramater buffer */
{
	char	*nodename;
	int	i,j,k, icom,iname, rtn;

/*** com check ***/
	icom = (-1);
	for( i=0; i<SC_S_NCOM ; ++i ) {
		if( !strcmp( sc_s_com[i].com, com ) ) {
			icom = i;break;
		}
	}
	if( icom < 0 )	goto ECOM;

/*** execute function ***/
	switch ( icom ) {
	  case 0:	rtn = tbl_read( name );	/* name <-- abbr */
			break;
	  case 1:	rtn = tbl_param( name, (int *)buf );
			break;
	  case 2:	rtn = tbl_int( name, buf->cdim, &i );
			buf->iarg = i;
			break;
	  case 3:	nodename = tbl_node( name );
			rtn = tbl_errno;
			if( rtn >= 0 )	strcpy( buf, nodename );
			else 		buf->carg = '\0';
			break;
	  default:	goto ELIBR;
	}

/*** end of the routine ***/
	return	rtn;

/*** error handling ***/
ECOM:
	return TBL_E_COMMAND;	/* illegal command */
ELIBR:
	return TBL_E_LIBRBUG;	/* library bug */
}
