/**
 *	_tbl_num.c	n.k.	june 9, 1992
 *	_tb2_num.c	k.f.	july 29, 1996
 *
 * Modifications:
 *
 *  int _tb2_num( tb2_Spec tb2, char* name )
 *         -  get serial number of name in the table 
 *    tb2  - table spec returned from tb2_read()
 *    name - name to be searched (in the first row, KEY="NAME")
 *  return: n>=0  -- serial number, successfully completed
 *           < 0  -- error (see tbl.h)
 *
 *  int _tbl_num( char* name )  -  get serial number of name in the table 
 *    name - name to be searched (in the first row, KEY="NAME")
 *  return: n>=0  -- serial number, successfully completed
 *           < 0  -- error (see tbl.h)
 *
 *  (cf.) char *tb2_name( tb2_Spec tb2, int n )
 *        -  get name from serial-number
**/
static char what_tb2num[] =
"@(#)_tb2_num.c, v2.0, n.f, k.f, table serial-to-name, jun.1992-oct.1996";

/*** definitions ***/
#include  "tb2.h"		/* error codes, default directory */

/*** static variables ***/

/**
 *   _tbl_num() - get serial number of name in the table
**/
int _tb2_num( tb2, name )
tb2_Spec *tb2;			/* table specification */
char  *name;			/* name to be searched */
{
    tb2_Entry *entry;			/* table entry */

    if ( !(tb2) )  goto EUNREAD;

    if ( !(entry = tb2_entryfind( tb2, name, 0, 'n' )) )  goto ENAME;

    return (entry->serial);

 EUNREAD:
#ifdef TBL_WARN
    fprintf( WARN_DEST, "_tb2_num %s: table is not read yet\n", TBL_VER );
#endif
    tb2_errno = TBL_E_UNREAD;
    return -1;

 ENAME:
#ifdef TBL_WARN
    fprintf( WARN_DEST, "_tb2_num %s: name '%s' not found in table '%s'\n", 
	    TBL_VER, name, tb2->filename );
#endif
    tb2_errno = TBL_E_NAME;
    return -1;
}

/**
 *   _tbl_num() - get serial number of name in the table (old interface)
**/
int _tbl_num( name )
char  *name;			/* name to be searched */
{
    return _tb2_num( default_tbl, name );
}
