/* This is dhtsimple.c --  Version 1.2
 * This code is copyright by
 *	Elmar Bartel 1993,
 *	Institut fuer Informatik, TU Muenchen, Germany  
 *	bartel@informatik.tu-muenchen.de
 * You may use this code as you wish, as long as this
 * comment with the above copyright notice is keept intact
 * and in place.
 */
#include "dhtvalue.h"

#define ConvertPrime 37

static unsigned long ConvertSimpleValue(dhtValue v) {
	unsigned long h= 1;
	h = (h * ConvertPrime) ^ ((unsigned long)v&0xff);
	h = (h * ConvertPrime) ^ (((unsigned long)v>>8)&0xff);
	h = (h * ConvertPrime) ^ (((unsigned long)v>>16)&0xff);
	h = (h * ConvertPrime) ^ (((unsigned long)v>>24)&0xff);
 	return h;
}
static int EqualSimpleValue(dhtValue v1, dhtValue v2) {
	return v1 == v2;
}
static dhtValue	DupSimpleValue(dhtValue v) {
	return v;
}
static void	FreeSimpleValue(dhtValue v) {
	return;
}
static void	DumpSimpleValue(dhtValue v, FILE *f) {
	fprintf(f, "%08x", v);
}
dhtValueProcedures dhtSimpleProcs = {
	ConvertSimpleValue,
	EqualSimpleValue,
	DupSimpleValue,
	FreeSimpleValue,
	DumpSimpleValue
};
