/* This is dhtvalue.h --  Version 1.2
 * This code is copyright by
 *	Elmar Bartel 1993,
 *	Institut fuer Informatik, TU Muenchen, Germany  
 *	bartel@informatik.tu-muenchen.de
 * You may use this code as you wish, as long as this
 * comment with the above copyright notice is keept intact
 * and in place.
 */
/*
 * @(#)modified by k.furukawa, kek, v1.2.1 aug.2005
 */
#ifndef DHT_VALUE_INCLUDED
#define DHT_VALUE_INCLUDED

#include <stdio.h>
 
#if defined(FXF)
#include "fxf.h"
#else
#ifndef _OSK
/* #include "malloc.h" */
#include <stdlib.h>
#endif /* _OSK */
#define	fxfAlloc		malloc
#define fxfFree(x,n)		free(x)
#endif /*FXF*/

#ifndef LOCAL
#define LOCAL	static
#endif

#ifdef GDATA
#define DATA
#else
#define DATA	extern
#endif

typedef enum {
	dhtOkStatus, dhtFailedStatus
} dhtStatus;

/* Here we define some value types used throughout the source */
typedef enum {
	dhtSimpleValue,
	dhtStringValue,
	dhtCompactMemoryValue,
	dhtMemoryValue,
	dhtBCMemValue,
	/* dhtNewValue */
	dhtValueTypeCnt
} dhtValueType;

DATA char *dhtValueTypeToString[dhtValueTypeCnt]
#ifdef GDATA
	= { "dhtSimpleValue",
	    "dhtStringValue",
	    "dhtCompactMemoryValue",
	    "dhtMemoryValue",
	    "dhtByteCountedMemoryValue"
	    /* , "dhtNewValue" */
	  }
#endif
;

typedef char 	*dhtValue;

typedef struct {
	unsigned long	(*Hash)(dhtValue);
	int		(*Equal)(dhtValue, dhtValue);
	dhtValue	(*Dup)(dhtValue);
	void		(*Free)(dhtValue);
	void		(*Dump)(dhtValue, FILE *);
} dhtValueProcedures;
extern dhtValueProcedures dhtSimpleProcs;
extern dhtValueProcedures dhtStringProcs;
extern dhtValueProcedures dhtCompactMemoryProcs;
extern dhtValueProcedures dhtMemoryProcs;
extern dhtValueProcedures dhtBCMemoryProcs;
/* extern dhtValueProcedures dhtNewProcs; */

DATA dhtValueProcedures *dhtProcedures[dhtValueTypeCnt]
#ifdef GDATA
	= { &dhtSimpleProcs,
	    &dhtStringProcs,
	    &dhtCompactMemoryProcs,
	    &dhtMemoryProcs,
	    &dhtBCMemoryProcs
	    /* , dhtNewProcs */
	  }
#endif
;
#endif /*DHT_VALUE_INCLUDED*/
