/**
 *     tbl_err.c  --  error handlin for "tbllib"
 *	N. Kamikubota July 5, 1992
 *
 * (1) tbl_errend()			: display err msg and exit
 * (2) tbl_errmsg( emsg )		: get error (warn) msg
 *
 * not yet optimised for version 2
 *
 * Modifications:
**/
static char what_tb2err[] =
"@(#)tb2_err.c, v2.0.1, n.k, k.f, linac table error, jul.1992-nov.1996";


/* include files */
#include <stdio.h>
#include "tb2.h"		/* definitions of errors */

/**
 *  tbl_errend  --  error message and exit
 *  N. Kamikubota  July 5 1992
 *	display error message and terminate the program
**/
void tbl_errend()
{
	char	errmsg[256];
	tbl_errmsg( errmsg );
	fprintf( stderr,"%s\n", errmsg );
	exit(1);
}

/**
 *  tbl_errmsg  -- error message
 *  N. Kamikubota  July 5 1992
 *	display error message
**/
int tbl_errmsg( emsg )
char	*emsg;	/* error message */
{
#ifdef TBL_E_SCLIB
	char	*m = "rtbllib";
#else
	char    *m = "tbllib";
#endif
	char	*v = TBL_VER;		/* version defined in tbl.h */
	char	scmsg[132];		/* message generated in sc_lib */

	switch( tbl_errno )	{

/* errors & warnintgs in "sc_lib" & Linac-Control-Network */
#ifdef TBL_E_SCLIB
	  case TBL_E_SCLIB:
		sc_errmsg( scmsg );
		sprintf( emsg, 
		  "%s %s: %s; sc_errno=%d", m,v,scmsg,sc_errno );break;
	  case TBL_E_NETPROT:
		sprintf( emsg, 
		  "%s %s: fail to connect to daemon due to Linac-network security", m,v );
		break;
	  case TBL_E_SCOPEN:
		sprintf( emsg,
		   "%s %s: unable to connect to daemon, assume daemon not ready", m,v );
		break;
#endif

/* errors in client side */
#ifdef TBL_E_COMMAND
	  case TBL_E_COMMAND:
		sprintf( emsg, "%s %s: illegal 'com' specified",m,v);break;
#endif
#ifdef TBL_E_LIBRBUG
	  case TBL_E_LIBRBUG:
		sprintf( emsg, "%s %s: error; tbllib library bug ?",m,v);break;
#endif

/* errors in tbl_read() */
	  case TBL_E_NOTFOUND:
		sprintf( emsg, "%s %s: specified table not found, or unable to open",m,v);break;
	  case TBL_E_ILLLINE:
		sprintf( emsg, "%s %s: table contain illegal formatted line",m,v);break;
	  case TBL_E_NULLTBL:
		sprintf( emsg, "%s %s: table contains no data",m,v);break;
	  case TBL_E_BUFFSIZE:
		sprintf( emsg, "%s %s: table contains too many data",m,v);break;
	  case TBL_E_KEYWORDS:
		sprintf( emsg, "%s %s: specified keywords definition is illegal",m,v);break;

/* errors in other tbl_XX() routines */
	  case TBL_E_UNREAD:
		sprintf( emsg, "%s %s: table file does not read yet",m,v);break;
	  case TBL_E_NAME:
		sprintf( emsg, "%s %s: specified name not found in the table",m,v);break;
	  case TBL_E_KEY:
		sprintf( emsg, "%s %s: specified keyword not found in the table",m,v);break;
	  case TBL_E_NONODE:
		sprintf( emsg, "%s %s: key=\"NODE\" not specified in the table",m,v);break;
	  case TBL_E_NONAME:
		sprintf( emsg, "%s %s: specified n(serial_number) is invalid",m,v);break;

/* successfully completed ! */
	  case 0:
		sprintf( emsg,
		  "%s %s: command successfully completed",m,v);break;
/* error not defined */
	  default:
		sprintf( emsg,
		  "%s %s: undefined error; tbl_errno=%d",m,v,tbl_errno);break;
	}
	return tbl_errno;
}
