/**
 *  tb2_misc.c
 *    k.furukawa, jul.29.1996.
 *
 *    miscellanious utility routines for table functions
 **/
static char what_tb2misc[] =
"@(#)tb2_misc.c, v2.1, k.furukawa, table misc. routines, jul-1996-oct.1996";

/*
#include <sys/types.h>
#include <malloc.h>
*/
#include <stdlib.h>

/*
 * tb2_malloc  --  allocate memory
 *    shared memory version should be provided in future
 */
void *tb2_malloc( size_t size )
{
    return (void *)malloc( size );		/* normal system malloc */
}

/*
 * tb2_strdup  --  copy string
 *    slightly better than others and uses tb2_malloc()
 */
char *tb2_strdup( const char *str )
{
    int len;
    char *copy;

    if (!str) return((char *) 0);

    len = strlen(str) + 1;
    if (!(copy = tb2_malloc((unsigned int)len)))
                return((char *) 0);
    memcpy(copy, str, len);
    return(copy);
}
